{Partial 6502 in PASM   07  

The purpose here is to evaluate speed and instruction set use, in terms of COG program space.  Registers in HUB.

Of course, there is gonna be far better ASM ways of doing this.  Gotta walk before you run!

This executes the demo code correctly, but that's probably about it.  It is however, over 1 Mhz in speed!

Needs address translation, improved flag state, stack, and other things...

Doug Dingus  Dec '08  MIT License

}

CON
  ' Set up the processor clock in the standard way for 80MHz on HYDRA
  _CLKMODE = xtal1 + pll8x
  _XINFREQ = 10_000_000 + 0000

VAR
  long    registers[9]      'Registers in HUB
        'registers[0]  A
        'registers[1]  X
        'registers[2]  Y
        'registers[3]  SP
        'registers[4]  PC
        'registers[5]  FR
        'registers[6]  Number of instructions to process  (This should be a passed parameter, but isn't right now)
        'registers[7]  Address of HUB Jump Table
  

PUB execute (start_address)

    registers[0] := 0                                   
    registers[1] := 0
    registers[2] := 0
    registers[3] := 0
    registers[4] := start_address
    registers[5] := 0
    registers[6] := 50_000_000             'lots of instructions!
    registers[7] := @opcode_jmp_table      'fetch pointer to HUB jump table


    cognew (@entry_6502, @registers)


DAT
                        org 0

entry_6502              mov     register_addr, PAR                              'latch on to the address of HUB memory locations
                        mov     _TEMP, register_addr                             'get ready to operate on it
                        mov     A, _TEMP                                         'pointer to A is same as register_addr
                        add     _TEMP, #4                                        'develop pointer to X register
                        mov     X, _TEMP                                        
                        add     _TEMP, #4                                        'develop pointer to Y
                        mov     Y, _TEMP                                        
                        add     _TEMP, #4                                        'develop pointer to SP
                        mov     SP, _TEMP                                        
                        add     _TEMP, #4                                        'develop pointer to PC 
                        mov     PC, _TEMP                                         
                        add     _TEMP, #4                                        'develop pointer to FR
                        mov     FR, _TEMP                                        
                        add     _TEMP, #4                                        'develop pointer to Instruction count
                        rdlong  _instructions, _TEMP                                        
                        add     _TEMP, #4                                        'develop pointer to Opcode Table pointer!
                        rdlong  opcode_jmp, _TEMP                                'move pointer to COG.
                                                            

fetch_opcode            rdlong  _PC, PC                                         'get the PC in the COG
                        rdbyte  _opcode, _PC                                    'get opcode from HUB
                        add     _PC, #1                                         'setup for next fetch
                        mov     _TEMP, _opcode                                  'prepare to develop jump table pointer
                        shl     _TEMP, #2                                       'convert to long pointer
                        add     _TEMP, opcode_jmp                               'realize pointer to jump table entry
                        rdlong  _jump_instruction, _TEMP                        'fetch the jump instruction needed
                        sub     _instructions, #1                               'one instruction gonna get done
_jump_instruction       nop     'self-modify this                               'jump to instruction




done                   wrlong   _PC, PC                                         'store PC for next instruction to use                                                        'need to add some stuff here to shorten instruction code

                       wrlong   _A, screena                                     'comment these out for speed
                       wrlong   _X, screenx                                     'just writing registers on the screen
                       wrlong   _Y, screeny
                       wrlong   _PC, screenpc
                       wrlong   _FR, screenfr


                        tjnz    _instructions, #fetch_opcode                     'next instruction
                       wrlong   _instructions, screen                            'debug to screen
end                     jmp     #end                                             'loop forever...  gonna reset the Prop anyway


'--------------------------- Partial 6502 instruction ----------------------------


'                       a9  LDA #xx
_LDA_IMM                rdbyte   _A, _PC              'get the immediate operand
                        add      _PC, #1                'add one byte for next fetch
                        wrbyte   _A, A                'store it in A register
                        jmp      #done

                        
'                       a2  LDX #xx
_LDX_IMM                rdbyte   _X, _PC              'get the immediate operand
                        add      _PC, #1                'add one byte for next fetch
                        wrbyte   _X, X                'store it in X register
                        jmp      #done 


'                       a0  LDY #xx
_LDY_IMM                rdbyte   _Y, _PC              'get the immediate operand
                        add      _PC, #1                'add one byte for next fetch
                        wrbyte   _Y, Y                'store it in Y register
                        jmp      #done

                        '98  TYA                                           
_TYA                    rdbyte  _A, Y
                        wrbyte  _A, A
                        jmp      #done



'                       9d  STA address, X
_STA_ABS_X              rdbyte   _X, X                 'prep X register
                        rdbyte   _A, A                 'prep A register
                        rdbyte   _TEMP, _PC             'address low
                        add      _PC, #1
                        rdbyte   _TEMP_A, _PC           'address high
                        add      _PC, #1
                        shl      _TEMP_A, #8            'combine address low and high
                        add      _TEMP, _TEMP_A          
                        add      _TEMP, _X               'add X to it to complete effective address
                        wrbyte   _A, _TEMP               'write A to effective address
                        jmp      #done


'                       bd  LDA address, X
_LDA_ABS_X              rdbyte   _X, X                 'prep X register
                        rdbyte   _TEMP, _PC             'address low
                        add      _PC, #1
                        rdbyte   _TEMP_A, _PC           'address high
                        add      _PC, #1
                        shl      _TEMP_A, #8            'combine address low and high
                        add      _TEMP, _TEMP_A          
                        add      _TEMP, _X               'add X to it to complete effective address
                        rdbyte   _A, _TEMP               'load A from effective address
                        wrbyte   _A, A
                        jmp      #done


'                       fe  INC address, X
_INC_ABS_X              rdbyte   _X, X                 'prep X register
                        rdbyte   _TEMP, _PC             'address low
                        add      _PC, #1
                        rdbyte   _TEMP_A, _PC           'address high
                        add      _PC, #1
                        shl      _TEMP_A, #8            'combine address low and high
                        add      _TEMP, _TEMP_A          
                        add      _TEMP, _X               'add X to it to complete effective address
                        rdbyte   _ALU, _TEMP             'read contents of effective address
                        add      _ALU, #1               'add one to it
                        wrbyte   _ALU, _TEMP             'write it all back to the HUB
                        jmp      #done


'                       ca  DEX                       
_DEX                    rdbyte  _X, X                 'get X from HUB
                        sub     _X, #1                'subtract 
                        wrbyte  _X, X                 'write it all back to HUB
                        jmp     #done


                        
'                       e0 CPX  #xx             'flag register is a simple equal or not hack at the moment        
_CPX_IMM                rdbyte  _ALU, _PC       'get value to compare into COG
                        add     _PC, #1         'update the PC
                        rdbyte  _X, X           'get X register into COG
                        cmp     _X, _ALU  wz    'are they equal or not?
                 if_z   mov     _FR, #1         'yes, equal!
                 if_nz  mov     _FR, #0         'NO!
                        wrbyte  _FR, FR         'write flag state to HUB
                        jmp     #done


'                       44 CMP  #xx             'flag register is a simple equal or not hack at the moment        
_CMP_IMM                rdbyte  _ALU, _PC       'get value to compare into COG
                        add     _PC, #1         'update the PC
                        rdbyte  _A, A           'get X register into COG
                        cmp     _A, _ALU  wz    'are they equal or not?
                 if_z   mov     _FR, #1         'yes, equal!
                 if_nz  mov     _FR, #0         'NO!
                        wrbyte  _FR, FR         'write flag state to HUB
                        jmp     #done


'                       d0 BNE label
_BNE                    rdlong  _PC, PC                     'get the current PC
                        add     _PC, #1                     'update it for next fetch
                        rdbyte  _FR, FR                     'get flags
                        rdbyte  _ALU, _PC                   'get branch address
                        add     _PC, #1                     'update PC for next fetch
                       tjnz     _FR, #no_branch             'if equal, bag on this!
                        and    _TEMP, SIGN_TEST   nr, wz     'test high bit to sign extend branch address
              if_nz      or     _ALU, MASK      wr          'it's a one, so do the sign extend
                        add     _PC, _ALU                   'add them up
no_branch               jmp     #done











DAT     'These are pointers to the HUB registers
register_addr           long         0  'Pointer to start of register block, not currently used for much
A                       long         0        'registers[0]  A
X                       long         0        'registers[1]  X
Y                       long         0        'registers[2]  Y
SP                      long         0        'registers[3]  SP
PC                      long         0        'registers[4]  PC
FR                      long         0        'registers[5]  FR
opcode_jmp              long         0

DAT      '_TEMP COG working registers
_A                       long         0        '  A
_X                       long         0        '  X
_Y                       long         0        '  Y
_SP                      long         0        '  SP
_PC                      long         0        '  PC
_ALU                     long         0        '  ALU
_FR                      long         0        '  FR
_opcode                  long         0        'current opcode 


'Internal COG working storage
_TEMP                    long         0  'workspace #1
_TEMP_A                  long         0  'workspace #2
_instructions            long         0  'registers[6]  Number of instructions to process



DAT    'working constants, masks and such
MASK              long         $FF_FF_FF_00                                     'For a sign extend to branch addresses
SIGN_TEST         long         %00000000_00000000_00000000_10000000             'Test high bit of branch address

DAT    'debug stuff
screen           long         $7e00                                            'Pointer to some location on the screen
screena          long         $7e28
screenx          long         $7e50
screeny          long         $7e78
screenpc         long         $7ea0
screenfr         long         $7ec8


DAT    'table of opcodes jmp instructions

opcode_jmp_table

op_00      long            $00_00_00_00              
op_01      long            $00_00_00_00
op_02      long            $00_00_00_00
op_03      long            $00_00_00_00
op_04      long            $00_00_00_00
op_05      long            $00_00_00_00
op_06      long            $00_00_00_00
op_07      long            $00_00_00_00
op_08      long            $00_00_00_00
op_09      long            $00_00_00_00
op_0A      long            $00_00_00_00
op_0B      long            $00_00_00_00
op_0C      long            $00_00_00_00
op_0D      long            $00_00_00_00
op_0E      long            $00_00_00_00
op_0F      long            $00_00_00_00

op_10      long            $00_00_00_00              
op_11      long            $00_00_00_00
op_12      long            $00_00_00_00
op_13      long            $00_00_00_00
op_14      long            $00_00_00_00
op_15      long            $00_00_00_00
op_16      long            $00_00_00_00
op_17      long            $00_00_00_00
op_18      long            $00_00_00_00
op_19      long            $00_00_00_00
op_1A      long            $00_00_00_00
op_1B      long            $00_00_00_00
op_1C      long            $00_00_00_00
op_1D      long            $00_00_00_00
op_1E      long            $00_00_00_00
op_1F      long            $00_00_00_00

op_20      long            $00_00_00_00              
op_21      long            $00_00_00_00
op_22      long            $00_00_00_00
op_23      long            $00_00_00_00
op_24      long            $00_00_00_00
op_25      long            $00_00_00_00
op_26      long            $00_00_00_00
op_27      long            $00_00_00_00
op_28      long            $00_00_00_00
op_29      long            $00_00_00_00
op_2A      long            $00_00_00_00
op_2B      long            $00_00_00_00
op_2C      long            $00_00_00_00
op_2D      long            $00_00_00_00
op_2E      long            $00_00_00_00
op_2F      long            $00_00_00_00

op_30      long            $00_00_00_00             
op_31      long            $00_00_00_00
op_32      long            $00_00_00_00
op_33      long            $00_00_00_00
op_34      long            $00_00_00_00
op_35      long            $00_00_00_00
op_36      long            $00_00_00_00
op_37      long            $00_00_00_00
op_38      long            $00_00_00_00
op_39      long            $00_00_00_00
op_3A      long            $00_00_00_00
op_3B      long            $00_00_00_00
op_3C      long            $00_00_00_00
op_3D      long            $00_00_00_00
op_3E      long            $00_00_00_00
op_3F      long            $00_00_00_00

op_40      long            $00_00_00_00            
op_41      long            $00_00_00_00
op_42      long            $00_00_00_00
op_43      long            $00_00_00_00
op_44      jmp          #_CMP_IMM
op_45      long            $00_00_00_00
op_46      long            $00_00_00_00
op_47      long            $00_00_00_00
op_48      long            $00_00_00_00
op_49      long            $00_00_00_00
op_4A      long            $00_00_00_00
op_4B      long            $00_00_00_00
op_4C      long            $00_00_00_00
op_4D      long            $00_00_00_00
op_4E      long            $00_00_00_00
op_4F      long            $00_00_00_00

op_50      long            $00_00_00_00            
op_51      long            $00_00_00_00
op_52      long            $00_00_00_00
op_53      long            $00_00_00_00
op_54      long            $00_00_00_00
op_55      long            $00_00_00_00
op_56      long            $00_00_00_00
op_57      long            $00_00_00_00
op_58      long            $00_00_00_00
op_59      long            $00_00_00_00
op_5A      long            $00_00_00_00
op_5B      long            $00_00_00_00
op_5C      long            $00_00_00_00
op_5D      long            $00_00_00_00
op_5E      long            $00_00_00_00
op_5F      long            $00_00_00_00

op_60      long            $00_00_00_00          
op_61      long            $00_00_00_00
op_62      long            $00_00_00_00
op_63      long            $00_00_00_00
op_64      long            $00_00_00_00
op_65      long            $00_00_00_00
op_66      long            $00_00_00_00
op_67      long            $00_00_00_00
op_68      long            $00_00_00_00
op_69      long            $00_00_00_00
op_6A      long            $00_00_00_00
op_6B      long            $00_00_00_00
op_6C      long            $00_00_00_00
op_6D      long            $00_00_00_00
op_6E      long            $00_00_00_00
op_6F      long            $00_00_00_00

op_70      long            $00_00_00_00           
op_71      long            $00_00_00_00
op_72      long            $00_00_00_00
op_73      long            $00_00_00_00
op_74      long            $00_00_00_00
op_75      long            $00_00_00_00
op_76      long            $00_00_00_00
op_77      long            $00_00_00_00
op_78      long            $00_00_00_00
op_79      long            $00_00_00_00
op_7A      long            $00_00_00_00
op_7B      long            $00_00_00_00
op_7C      long            $00_00_00_00
op_7D      long            $00_00_00_00
op_7E      long            $00_00_00_00
op_7F      long            $00_00_00_00

op_80      long            $00_00_00_00           
op_81      long            $00_00_00_00
op_82      long            $00_00_00_00
op_83      long            $00_00_00_00
op_84      long            $00_00_00_00
op_85      long            $00_00_00_00
op_86      long            $00_00_00_00
op_87      long            $00_00_00_00
op_88      long            $00_00_00_00
op_89      long            $00_00_00_00
op_8A      long            $00_00_00_00
op_8B      long            $00_00_00_00
op_8C      long            $00_00_00_00
op_8D      long            $00_00_00_00
op_8E      long            $00_00_00_00
op_8F      long            $00_00_00_00

op_90      long            $00_00_00_00            
op_91      long            $00_00_00_00
op_92      long            $00_00_00_00
op_93      long            $00_00_00_00
op_94      long            $00_00_00_00
op_95      long            $00_00_00_00
op_96      long            $00_00_00_00
op_97      long            $00_00_00_00
op_98      jmp          #_TYA
op_99      long            $00_00_00_00
op_9A      long            $00_00_00_00
op_9B      long            $00_00_00_00
op_9C      long            $00_00_00_00
op_9D      jmp          #_STA_ABS_X                   'sta numbers, x
op_9E      long            $00_00_00_00
op_9F      long            $00_00_00_00

op_A0      jmp          #_LDY_IMM                     'ldy #xx             
op_A1      long            $00_00_00_00
op_A2      jmp          #_LDX_IMM                     'ldx #xx
op_A3      long            $00_00_00_00
op_A4      long            $00_00_00_00
op_A5      long            $00_00_00_00
op_A6      long            $00_00_00_00
op_A7      long            $00_00_00_00
op_A8      long            $00_00_00_00
op_A9      jmp          #_LDA_IMM                     'LDA #xx      
op_AA      long            $00_00_00_00
op_AB      long            $00_00_00_00
op_AC      long            $00_00_00_00
op_AD      long            $00_00_00_00
op_AE      long            $00_00_00_00
op_AF      long            $00_00_00_00

op_B0      long            $00_00_00_00            
op_B1      long            $00_00_00_00
op_B2      long            $00_00_00_00
op_B3      long            $00_00_00_00
op_B4      long            $00_00_00_00
op_B5      long            $00_00_00_00
op_B6      long            $00_00_00_00
op_B7      long            $00_00_00_00
op_B8      long            $00_00_00_00
op_B9      long            $00_00_00_00
op_BA      long            $00_00_00_00
op_BB      long            $00_00_00_00
op_BC      long            $00_00_00_00
op_BD      jmp          #_LDA_ABS_X            'lda $xxxx, X
op_BE      long            $00_00_00_00
op_BF      long            $00_00_00_00

op_C0      long            $00_00_00_00           
op_C1      long            $00_00_00_00
op_C2      long            $00_00_00_00
op_C3      long            $00_00_00_00
op_C4      long            $00_00_00_00
op_C5      long            $00_00_00_00
op_C6      long            $00_00_00_00
op_C7      long            $00_00_00_00
op_C8      long            $00_00_00_00
op_C9      long            $00_00_00_00
op_CA      jmp          #_DEX                          'DEX
op_CB      long            $00_00_00_00
op_CC      long            $00_00_00_00
op_CD      long            $00_00_00_00
op_CE      long            $00_00_00_00
op_CF      long            $00_00_00_00

op_D0      jmp          #_BNE                       'BNE  #xx
op_D1      long            $00_00_00_00
op_D2      long            $00_00_00_00
op_D3      long            $00_00_00_00
op_D4      long            $00_00_00_00
op_D5      long            $00_00_00_00
op_D6      long            $00_00_00_00
op_D7      long            $00_00_00_00
op_D8      long            $00_00_00_00
op_D9      long            $00_00_00_00
op_DA      long            $00_00_00_00
op_DB      long            $00_00_00_00
op_DC      long            $00_00_00_00
op_DD      long            $00_00_00_00
op_DE      long            $00_00_00_00
op_DF      long            $00_00_00_00

op_E0      jmp          #_CPX_IMM                  'CPX  #xx
op_E1      long            $00_00_00_00
op_E2      long            $00_00_00_00
op_E3      long            $00_00_00_00                       
op_E4      long            $00_00_00_00
op_E5      long            $00_00_00_00
op_E6      long            $00_00_00_00
op_E7      long            $00_00_00_00
op_E8      long            $00_00_00_00
op_E9      long            $00_00_00_00
op_EA      long            $00_00_00_00
op_EB      long            $00_00_00_00
op_EC      long            $00_00_00_00
op_ED      long            $00_00_00_00
op_EE      long            $00_00_00_00
op_EF      long            $00_00_00_00

op_F0      long            $00_00_00_00            
op_F1      long            $00_00_00_00
op_F2      long            $00_00_00_00
op_F3      long            $00_00_00_00
op_F4      long            $00_00_00_00
op_F5      long            $00_00_00_00
op_F6      long            $00_00_00_00
op_F7      long            $00_00_00_00
op_F8      long            $00_00_00_00
op_F9      long            $00_00_00_00
op_FA      long            $00_00_00_00
op_FB      long            $00_00_00_00
op_FC      long            $00_00_00_00
op_FD      long            $00_00_00_00
op_FE      jmp          #_INC_ABS_X             'inc $xxxx, X
op_FF      jmp          #end                    'artifical halt instruction   